/*
 * @Description: 
 * @Version: 2.0
 * @Autor: ftt
 * @Date: 2022-03-23 15:56:16
 * @LastEditors: TT
 * @LastEditTime: 2022-08-16 17:36:53
 */

import 'package:flutter_easyrefresh/easy_refresh.dart';
import 'package:get/get.dart';
import 'package:ttcomment/ttcomment.dart';

abstract class NormalGetxController extends GetxController {
  var pageState = PageState.initializedState.obs;

  var sizew = 0.0.obs;

  configsiezw(double maxw) {
    sizew.value = maxw;
  }

  /// 配置点击失败界面 刷线方法
  configreload() {}
}

abstract class NormalGetxListController extends NormalGetxController
    implements AbstractNetWork {
  EasyRefreshController? refreshController;
  int page = 1;

  @override
  void onInit() {
    super.onInit();
    refreshController = EasyRefreshController();
  }

  // 下啦刷新触发事件
  configRefresh() async {
    page = 1;
    getnetworkdata(1, configNetWorkParmas());
  }

  // 上啦加载更多触发事件
  configLoading() async {
    page++;
    getnetworkdata(2, configNetWorkParmas());
  }

  /// 网络请求 参数方法
  @override
  Map<String, dynamic>? configNetWorkParmas() {
    return null;
  }

  /// 网络请求数据
  @override
  void getnetworkdata(int? type, Map<String, dynamic>? info) async {}

  /// 通过数据 进行 pagestate 转换
  configListPageState({
    required int allnum,
    required int networknum,
  }) {
    PageState st = PageState.dataFetchState;
    if (allnum == 0) {
      st = PageState.emptyDataState;
    } else if (networknum == 0) {
      st = PageState.noMoreDataState;
    }
    return st;
  }

  /// 结束刷新
  void endRefresh({int? type, PageState? state}) {
    bool success = true;
    bool noMore = false;
    if (state == PageState.noMoreDataState) {
      noMore = true;
    }
    if (state == PageState.errorState ||
        state == PageState.erroronlyTotal ||
        state == PageState.errorshowRelesh) {
      success = false;
    }
    if (refreshController != null) {
      if (type == 1) {
        refreshController!.finishRefresh(success: success);
        refreshController!.resetLoadState();
      } else if (type == 2) {
        refreshController!.finishLoad(success: success, noMore: noMore);
      }
    }
    pageState.value = state!;
  }
}
