/*
 * @Description: 
 * @Version: 2.0
 * @Autor: ftt
 * @Date: 2022-03-23 15:56:41
 * @LastEditors: TT
 * @LastEditTime: 2022-06-23 09:05:46
 */
import 'package:flutter/material.dart';
import 'package:flutter_easyrefresh/easy_refresh.dart';
import 'hzy_normal_getx_list_controller.dart';
import 'hzy_normal_getx_view.dart';
import 'package:ttcomment/ttcomment.dart';

// ignore: must_be_immutable
abstract class NormalGetxListView<T extends NormalGetxListController>
    extends NormaGetxView<T> with AbstracRefreshWidget {
  NormalGetxListView({Key? key}) : super(key: key);

  @override
  Widget createBody(BuildContext context) {
    return createRefreshWidget(context);
  }

  @override
  Widget createRefreshWidget(BuildContext context) {
    return EasyRefresh(
      key: key,
      controller: controller.refreshController ?? EasyRefreshController(),
      onRefresh: () async {
        controller.configRefresh();
      },
      onLoad: () async {
        controller.configLoading();
      },
      child: createListView(context),
      header: createHeader(),
      footer: createFooter(),
      emptyWidget: createEmptyWidget(),
    );
  }

  Header? createHeader() {
    return ClassicalHeader(
      refreshingText: '正在刷新...',
      refreshedText: '刷新成功',
      refreshReadyText: '松开刷新',
      refreshFailedText: '刷新失败',
      refreshText: '下拉刷新',
      showInfo: false,
      textColor: CommentColorS.col000000,
    );
  }

  Footer? createFooter() {
    return ClassicalFooter(
      loadText: "上啦加载更多数据",
      loadReadyText: "松开加载",
      loadingText: "正在加载...",
      loadedText: "加载成功",
      loadFailedText: "加载失败",
      noMoreText: "没有更多数据了~",
      showInfo: false,
      textColor: CommentColorS.col000000,
    );
  }
}
