/*
 * @Description: 
 * @Version: 2.0
 * @Autor: ftt
 * @Date: 2022-03-23 15:57:09
 * @LastEditors: ftt
 * @LastEditTime: 2022-06-14 15:12:14
 */

import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:ttcomment/ttcomment.dart';
import 'hzy_normal_getx_list_controller.dart';
import 'hzy_normal_utils.dart';

// ignore: must_be_immutable
abstract class NormaGetxView<T extends NormalGetxController> extends GetView<T>
    with AbstractAttribute, AbstractWidget {
  NormaGetxView({Key? key}) : super(key: key);

  @override
  PageState get pageState => controller.pageState.value;
  @override
  Widget build(BuildContext context) {
    return createScaffol(
        context: context,
        safeAreatop: safeAreatop,
        safeAreabottm: safeAreabottm,
        pageState: pageState,
        title: title,
        backgroundColor: backgroundColor,
        navbackcolor: navbackcolor,
        resizeToAvoidBottomInset: resizeToAvoidBottomInset);
  }

  /// 抽离通用colum 方法,用layoutbuilder包裹的目的
  /// 为了解决web 开发时,设置最大布局
  /// 分为 createObxWidget() 和 createObxColumWidget()
  @override
  Widget createColumWidget(BuildContext context) {
    return Container(
      alignment: Alignment.center,
      child: LayoutBuilder(
        builder: (context, constraints) {
          configlayoutbuiderConstraints(constraints);
          return Container(
            alignment: Alignment.centerLeft,
            width: configSizeBoxWidth(constraints),
            child: createObxWidget(),
          );
        },
      ),
    );
  }

  /// 为 getx 新增包裹方法
  Widget createObxWidget() {
    return Obx(
      () => createObxColumWidget(),
    );
  }

  /// getx 真实包裹的colum 方法
  Widget createObxColumWidget() {
    return Column(
      children: [
        createHeaderWidget(),
        Expanded(
          child: createBody(Get.context!),
        ),
      ],
    );
  }

  /// 获取 屏幕 最大尺寸
  configlayoutbuiderConstraints(BoxConstraints constraints) {
    controller.configsiezw(configSizeBoxWidth(constraints));
  }

  double configSizeBoxWidth(BoxConstraints constraints) {
    return HzyNormalUtils.configSizeMaxW(constraints.maxWidth);
  }
}
